#!/usr/bin/python
# -*- coding: utf-8 -*-
# Grid management for CellTracking
# MW 2012 GPLv3+

import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade

import gobject
import math, copy, os, time

class Object :
	"""A stupid object"""

class Grid :
	def __init__(self, movie):
		self.movie = movie
		self.initiated = False
		self.visible = False
		self.editable = False
		
		self.origin = [-1, -1]
		self.origin_max = (-1, -1)
		
		self.spacing = [-1, -1]
		self.spacing_max = (-1, -1)
		
		self.size = [-1, -1]
		self.size_max = (-1, -1)
		
		self.angle = 0	# in degrees
		
		self.reference_size = 15		# At the wrong place ?
		
		self.grid_folder = None
		self.v_set_visible = False
		
		# grid buttons
		self.gtk_b_hide_show_grid = None
		self.gtk_b_process_grid =  None
	
	def _process_select_all(self, w) :
		# Set selected flag on the cells
		# Update check should work
		l_cells = self.movie.cells.get_cells_list()
		for c in l_cells :
			c.select(True)
		for c in l_cells :
			print c.is_selected()
				
	def _process_select_none(self, w) :
		# Set selected flag on the cells
		# Update check should work
		l_cells = self.movie.cells.get_cells_list()
		for c in l_cells :
			c.unselect(True)
		for c in l_cells :
			print c.is_selected()
	
	def _process_export_selected(self, w) :
		# Show fileselect dialog
		gtk = self.gtk
		chooser = gtk.FileChooserDialog(title='Choose export folder',action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER, buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
		response = chooser.run()
		r = False
		if response == gtk.RESPONSE_OK:
			exp = chooser.get_filename()+'/export-'+str(self.movie.get_name()) + '/'
			if not os.path.isdir(exp) :
				os.mkdir(exp)
			r = True
		elif response == gtk.RESPONSE_CANCEL:
			pass
		chooser.destroy()
		if r :
			#obj = Object()
			#obj.index = 0
			#i = 0
			#l_cells = self.movie.cells.get_cells_list()
			l_cells = self.movie.cells2.get_cells_list()
			for c in l_cells :
				if c.is_selected() :
					print "-- Cell %s" % str(c.get_label())
					t = time.strftime("%d-%m-%Y--%Hh%M", time.localtime())
					folder = exp + str(self.movie.channels.get_association_names_table()[self.movie.get_view()[0]]) + '-' + str(c.get_label()) + '--' + t + '/'
					os.mkdir(folder)
					for i in range(self.movie.get_nb_frames()) :
						if i % 20 == 0 :
							print "image %s" % str(i)
						path = folder + 'image'+str(i) + '.png'
						path_cm = folder + 'image_cm'+str(i) + '.png'
						path_rm = folder + 'image_rm'+str(i) + '.png'
						c.export_frame(i, (path, path_cm, path_rm))
					#c.export_cell(folder, warning=False, index=i, obj=obj) # Call export function (export the whole movie, gives it a folder URL
					#i+=1
	
	def _process_find_phases_selected(self, w) :
		l_cells = self.movie.cells.get_cells_list()
		print 'Finding phases'
		for c in l_cells :
			if c.is_selected() :
				c.find_phases(warning = False)
			
	
	def draw_process_grid(self, movie_gtk, movie) :
		"""Draws the process grid window"""
		movie_gtk.b_set_grid.set_sensitive(False)
		#movie_gtk.lock()	# Lock panel
		gtk = movie_gtk.selff.gtk
		self.gtk = gtk
		self.movie_gtk = movie_gtk
		self.movie = movie
		if self.v_set_visible :
			self._done()		# Closing set window
		self.widgets_process = gtk.glade.XML('./modules_core/grid.glade',"ProcessGrid")
		events = { '_close' : self._close_process,
				'process_ok' : self._process_ok,
				'_process_select_all' : self._process_select_all, 
				'_process_select_none' : self._process_select_none,
				'_process_export_selected' : self._process_export_selected,
				'_process_find_phases_selected' : self._process_find_phases_selected,
				'_process_extract_fluo_selected' : self._process_extract_fluo_selected}
		self.widgets_process.signal_autoconnect(events)	
		self.window_process = self.widgets_process.get_widget('ProcessGrid')
		self.window_process.set_title(movie.get_name())				# Set title
		self.scroll_process = self.widgets_process.get_widget('main_frame')
		self.box_process = gtk.VBox()
		self.box_process.show()
		self.scroll_process.add_with_viewport(self.box_process)
		
		# Create frame
		# ================ MODIFIED PART
		for c in self.movie.cells2.get_cells_list() :
			frame = c.gui.new_frame(self.gtk)
			frame.show()
			self.box_process.add(frame)
		
		self.timer_process = gobject.timeout_add(200, self._update_cells, {'gtk' : gtk, 'movie' : movie, 'cells' : movie.cells}) # call every 150ms
	
	def _process_extract_fluo_selected(self, w, data=None) :
		l_cells = self.movie.cells.get_cells_list()
		obj = Object()
		obj.index = 0
		i = 0
		for c in l_cells :
			if c.is_selected() :#and c.is_cell() :
				c.extract_fluo('', i, obj)
				i+=1
		# (Check if they are real cells)
		# Launch extract fluo instance

	def _update_cells(self, d) :
		gtk = d['gtk']
		cells = d['cells']
		#for c in cells.get_cells_list() :
		for c in self.movie.cells2.get_cells_list() :
			# Updating phase
			c.set_frame(d['movie'].get_frame_index())
			#c.update_panel()
			c.gui.update_panel()
		return True
	
	#def _b_edit_grid(self, w, data=None) :
	#	self.set_main_table.set_sensitive(True)
	#	w.set_sensitive(False)
	
	def draw_set_grid(self, movie_gtk, movie) :
		"""Showing the grid settings window"""
		gtk = movie_gtk.selff.gtk
		self.gtk = gtk
		self.movie_gtk = movie_gtk
		self.movie = movie
		if not self.v_set_visible :
			self.widgets_set = gtk.glade.XML('./modules_core/grid.glade',"GridSettings")
			events = { '_close' : self._close_set,
				'_change_origin' : self._change_origin,
				'_change_angle' : self._change_angle,
				'_change_spacing' :  self._change_spacing,
				'_change_size' : self._change_size,
				'_done' : self._done,
				'_cancel' : self._cancel,
				'_show_hide_grid' : self.show_hide_grid,
				'_reset' : self._reset_grid,
				'_load_grid' : self._load_grid,
				'_save_grid' : self._save_grid,
				'_save_as_grid' : self._save_as_grid,}
				#'_edit_grid' : self._b_edit_grid,}
			self.widgets_set.signal_autoconnect(events)	
			self.window_set = self.widgets_set.get_widget('GridSettings')

			if not self.initiated :
				self._grid_init(self.movie_size)
			
			self._set_visible()
			self._set_editable()
			
			# Binding buttons
			self.set_main_table = self.widgets_set.get_widget('main_table')
			#self.set_main_table.set_sensitive(False)
			self.b_origin_x = self.widgets_set.get_widget('b_origin_x')
			self.b_origin_y = self.widgets_set.get_widget('b_origin_y')
			self.b_angle = self.widgets_set.get_widget('b_angle')
			self.b_spacing_x = self.widgets_set.get_widget('b_spacing_x')
			self.b_spacing_y = self.widgets_set.get_widget('b_spacing_y')
			self.b_size_x = self.widgets_set.get_widget('b_size_x')
			self.b_size_y = self.widgets_set.get_widget('b_size_y')
			
			self._update_set_panel()
			
			self.old  = {'origin' : copy.copy(self.origin),
					'origin_max' : copy.copy(self.origin_max),
					'angle' : copy.copy(self.angle),
					'spacing' : copy.copy(self.spacing),
					'spacing_max' : copy.copy(self.spacing_max),
					'size' : copy.copy(self.size),
					'size_max' : copy.copy(self.size_max),
					'cells' : movie.cells.get_cells_list(),}	
			self.v_set_visible = True
			## Needs an updating timer here (but see when the mouse bindings will be coded)	
			self.timer_set = gobject.timeout_add(200, self._update_set_panel, {}) # call every 200ms

	def _update_set_panel(self, data=None) :
		self.b_origin_x.set_range(0, self.origin_max[0])
		self.b_origin_x.set_value(self.origin[0])
		self.b_origin_y.set_range(0, self.origin_max[1])
		self.b_origin_y.set_value(self.origin[1])
		self.b_angle.set_value(self.angle)
		self.b_spacing_x.set_range(15, self.spacing_max[0])
		self.b_spacing_x.set_value(self.spacing[0])
		self.b_spacing_y.set_range(15, self.spacing_max[1])
		self.b_spacing_y.set_value(self.spacing[1])
		self.b_size_x.set_range(40, self.size_max[0])
		self.b_size_x.set_value(self.size[0])
		self.b_size_y.set_range(40, self.size_max[1])
		self.b_size_y.set_value(self.size[1])
		return True	
	def _process_ok(self, source=None, event=None) :
		self._close_process()	
	def _set_visible(self) :
		self.visible = True
	def _set_invisible(self) :
		self.visible = False
	def hide_grid(self) :
		self.visible = False
		self.editable = False
	def _set_editable(self) :
		self.editable = True
	def _set_uneditable(self) :
		self.editable = False
	def grid_init(self, movie, movie_gtk) :
			self.movie = movie
			self.movie_gtk = movie_gtk
			"""Initiates the default grid
			THIS IS A TMP FEATURE DON'T USE IT"""
			#self._grid_init(self.movie_size)
			self._set_visible()
			self._set_editable()
	
	def _grid_init(self, size) :
		"""Sets the grid to defaults values"""
		print 'init'
		x_m = size[0] - 1
		y_m = size[1] - 1
		
		# Origin
		self.origin_max = (x_m, y_m)
		self.origin = [int(0.2*x_m), int(0.2*y_m)]
		self.angle = 0
		
		# Size
		self.size_max = [int(0.3*x_m), int(0.3*y_m)]
		self.size = [int(self.size_max[0]/2), int(self.size_max[1]/2)]
		
		# Spacing
		self.spacing = [int(0.5*x_m), int(0.5*y_m)]
		self.spacing_max = [int(0.8*x_m), int(0.8*y_m)]
		
		self.initiated = True
	def set_cv_grid(self, cv, movie) :
		"""Required to initiate the CV instance"""
		self.cv = cv
		self.movie_size = movie.get_size()
	def grid_update(self, image) :
		"""Here come the drawing functions"""
		if self.visible :
			if not self.initiated :
				self._grid_init(self.movie_size)
			if self.editable :
				image = self._draw_grid_editable(image)
			image = self._draw_grid_non_editable(image)
		return image
	def _draw_grid_non_editable(self, image) :
		"""Draws the non editable part of the grid"""
		cv = self.cv
		l = self.movie.cells.get_cells_list()
		for cell in l :
			cell.draw_cell(cv, image, True)	# True : draw reference
		return image
	def grid_init2(self) :
		"""Function that initiates the grid (and the cells) without interfering with the display
		However, it generates the grid parameters for drawing (lines and circles)"""
		self.movie.cells.clear_cells_list()
		circles = []
		
		k=0
		[orig_x, orig_y] = self.origin
		[spac_x, spac_y] = self.spacing
		
		[max_x, max_y] = self.movie_size
		[max_x, max_y] = [max_x-1, max_y-1]
		angle = -1*math.pi/180*float(self.angle)
		
		# Horizontal Lines
		h_list = []
		k = 0
		pt1 = (0, int(orig_y + k*spac_y/math.cos(angle) - orig_x*math.tan(angle)))
		pt2 = (max_x, int(orig_y + k*spac_y/math.cos(angle) + max_x*math.tan(angle)) )
		while pt1[1]  <= max_y or pt2[1] <= max_y :
			k+=1
			pt1 = (0, int(orig_y + k*spac_y/math.cos(angle) - orig_x*math.tan(angle)))
			pt2 = (max_x, int(orig_y + k*spac_y/math.cos(angle) + (max_x-orig_x)*math.tan(angle)) )
		while pt1[1] > 0 or pt2[1] > 0 :
			h_list.append([pt1,pt2])
			#cv.Line(image, pt1, pt2, (255,0,0))
			k-=1
			h_list.append((pt1,pt2))
			pt1 = (0, int(orig_y + k*spac_y/math.cos(angle) - orig_x*math.tan(angle)))
			pt2 = (max_x, int(orig_y + k*spac_y/math.cos(angle) + (max_x-orig_x)*math.tan(angle)) )
		
		# Vertical lines
		k = 0
		v_list = []
		pt1 = (int(orig_x + k*spac_x/math.cos(angle) + orig_y*math.tan(angle)), orig_y)
		pt2 = (int(orig_x + k*spac_x/math.cos(angle) + (max_y-orig_y)*math.tan(angle)), max_y )
		while pt1[0]  <= max_x or pt2[0] <= max_x :
			k+=1
			pt1 = (int(orig_x + k*spac_x/math.cos(angle) + orig_y*math.tan(angle)), 0)
			pt2 = (int(orig_x + k*spac_x/math.cos(angle) - (max_y-orig_y)*math.tan(angle)), max_y )
		while pt1[0]  > 0 or pt2[0] > 0 :
			v_list.append((pt1,pt2))
			#cv.Line(image, pt1, pt2, (255,0,0))
			k-=1
			pt1 = (int(orig_x + k*spac_x/math.cos(angle) + orig_y*math.tan(angle)), 0)
			pt2 = (int(orig_x + k*spac_x/math.cos(angle) - (max_y-orig_y)*math.tan(angle)), max_y )
		
		# Moving point
		handle = (int(orig_x + spac_x*math.cos(angle)), int(orig_y + spac_x*math.sin(angle)))
		self.handle_space_x = handle
		circles.append((handle, 10, (255,0,0), -1))
		#cv.Circle(image, handle, 10, (255,0,0), -1)

		handle = (int(orig_x - spac_y*math.sin(angle)), int(orig_y + spac_y*math.cos(angle)))
		self.handle_space_y = handle
		circles.append((handle, 10, (255,0,0), -1))
		#cv.Circle(image, handle, 10, (255,0,0), -1)		
		
		circles.append(((int(orig_x),int(orig_y)), 10, (255,0,0), -1))
		#cv.Circle(image, (int(orig_x),int(orig_y)), 10, (255,0,0), -1)
		
		# Get cells centers
		cent_l = []
		for d1 in h_list :
			for d2 in v_list :
				p = self._intersection(d1, d2)
				circles.append(((int(p[0]),int(p[1])), 10, (255,0,0), -1))
				#cv.Circle(image, (int(p[0]),int(p[1])), 10, (255,0,0), -1)
				cent_l.append((int(p[0]),int(p[1])))
		c_list = []
		for c in cent_l :
			cell = self.movie.cells.add_cell(c, self.size, self.angle)	# Add cell
			#print [c, self.origin]
			#if c == (self.origin[0], self.origin[1]) :		# In practice te center can move by one or two pixels when rotating
			if self._dist(c, self.origin, 3) :
				self.handle_size = cell.get_rect()[1]
				circles.append((cell.get_rect()[1], 5, (255,255,0), -1))
				#cv.Circle(image, cell.get_rect()[1], 5, (255,255,0), -1)
			if cell.is_all_in_screen() :			# Check if in screen
				c_list.append(c)			# Add to out_list
		
		self.movie.cells.clear_cells_list()
		l = list(set(c_list))
		l.sort()
		for c in l :
			cell = self.movie.cells.add_cell(c, self.size, self.angle)	# Add cell
			cell.set_ref(self.reference_size)
		lines = h_list+v_list
		return (lines, circles)
		
	def _draw_grid_editable(self, image) :
		"""Function that draws the grid with the editing features"""
		cv = self.cv
		(lines,circles) = self.grid_init2()
		for (pt1,pt2) in lines :
			cv.Line(image, pt1, pt2, (255,0,0))
		for (pt, radius, color, i) in circles :
			cv.Circle(image, pt, radius, color, i)
		return image
	
	def mouse_update(self,pt) :
		"""Updates some positions when a click is performed"""
		if self.editable and self.visible and self.initiated :
			h_orig = self.origin		# Get variables
			h_size = self.handle_size
			h_spac_x = self.handle_space_x
			h_spac_y = self.handle_space_y
			if self._dist(pt, h_orig, 5) :	# See which handle has been clicked
				self.origin = pt
			elif self._dist(pt, h_spac_x, 17) :
				self.spacing = (self._dist(pt, self.origin, None, True), self.spacing[1])
				self.size_max = (self.spacing[0] + self.reference_size, self.size_max[1])
				self.h_spac_x = pt
				dy = pt[1]- self.origin[1]
				x = self.origin[0] - pt[0]
				a =  math.atan(float(dy)/x)/math.pi*180 # Calculate new angle
				if a >= -45 and a <= 45 :
					self.angle = a
			elif self._dist(pt, h_spac_y, 17) :
				self.spacing = (self.spacing[0], self._dist(pt, self.origin, None, True))
				self.size_max = (self.size_max[0], self.spacing[1] + self.reference_size)
				self.h_spac_y = pt
				dx = self.origin[0] - pt[0]
				y = self.origin[1] - pt[1]
				a = math.atan(float(dx)/y)/math.pi*180
				if a >= -45 and a <= 45 :
					self.angle = a
	
	def _dist(self, pt1,pt2, threshold, return_dist=False) :
		r = False
		if return_dist :
			r = ((pt1[0]-pt2[0])**2+(pt1[1]-pt2[1])**2)**0.5
		elif (pt1[0]-pt2[0])**2+(pt1[1]-pt2[1])**2 < threshold**2 :
			r = True
		return r
	def _intersection(self, d1, d2) :
		"""Returns the intersection point of two lines that cut once,
		d1 and d2 are tuples of two points on the line"""
		# Getting coefficients of the line equation
		x_a1 = d1[0][0]
		x_a2 = d2[0][0]
		x_b1 = d1[1][0]
		x_b2 = d2[1][0]
		y_a1 = d1[0][1]
		y_a2 = d2[0][1]
		y_b1 = d1[1][1]
		y_b2 = d2[1][1]
		
		x_int = None
		y_int = None
		sl_1 = None
		sl_2 = None
		
		if x_b1 != x_a1 :
			sl_1 = float(y_b1-y_a1)/(x_b1-x_a1)
			of_1 = y_a1 - x_a1*sl_1
		else :
			x_int = x_a1
		if x_b2 != x_a2 :
			sl_2 = float(y_b2-y_a2)/(x_b2-x_a2)
			of_2 = y_a2 - x_a2*sl_2
		else :
			x_int = x_a2
			
		
		if x_int == None :
			x_int = (of_2 - of_1)/(sl_1-sl_2)
			y_int = sl_1*x_int + of_1
		elif sl_2 != None :
			y_int = sl_2*x_int + of_2
		elif sl_1 != None :
			y_int = sl_1*x_int + of_1
		else :
			print "Grid error"
			
		
		return (x_int, y_int)		 
	def _reset_grid(self, source=None, event=None) :
		"""Resets grid to its default values"""
		self._grid_init(self.movie_size)
	def _close_set(self, source=None, event=None) :
		self.v_set_visible = False
		gobject.source_remove(self.timer_set)
		self.window_set.destroy()
	def _close_process(self, source=None, event=None) :
		#self.movie_gtk.unlock()
		self.movie_gtk.b_set_grid.set_sensitive(True)
		gobject.source_remove(self.timer_process)
		self.window_process.destroy()
	def _change_origin(self, source=None, event=None) :
		# Checks if the value is ok
		n = source.get_name()
		if n=='b_origin_x' :
			self.origin = (int(source.get_value()), self.origin[1])
		elif n=='b_origin_y' :
			self.origin = (self.origin[0], int(source.get_value()))
		else :
			print 'Click shows bad properties...'
	
	def _change_angle(self, source=None, event=None):
		self.angle = source.get_value()
	
	def _change_spacing(self, source=None, event=None):
		n = source.get_name()
		if n=='b_spacing_x' :
			self.spacing = (int(source.get_value()), self.spacing[1])
			self.size_max = (int(source.get_value()/2.0) + self.reference_size, self.size_max[1])
			self.b_size_x.set_range(5, self.size_max[0])
		elif n=='b_spacing_y' :
			self.spacing = (self.spacing[0], int(source.get_value()))
			self.size_max = (self.size_max[0], int(source.get_value()/2.0) + self.reference_size)
			self.b_size_y.set_range(5, self.size_max[1])
		else :
			print 'Click shows bad properties...'
	
	def _change_size(self, source=None, event=None):
		n = source.get_name()
		if n=='b_size_x' :
			self.size = (int(source.get_value()), self.size[1])
		elif n=='b_size_y' :
			self.size = (self.size[1], int(source.get_value()))
		else :
			print 'Click shows bad properties...'
	
	def _done(self, source=None, event=None):
		self.movie_gtk.b_process_grid.set_sensitive(True)
		self._set_uneditable()
		self._close_set('','')
	
	def _cancel(self, source=None, event=None):
		"""Resets initial values and exit"""
		d = self.old
		self.origin = d['origin']
		self.origin_max	 = d['origin_max']
		self.angle  = d['angle']
		self.spacing  = d['spacing']
		self.spacing_max  = d['spacing_max']
		self.size  = d['size']
		self.size_max  = d['size_max']
		self.movie.cells.set_cells_list(d['cells'])
		self._close_set('','')
	def _load_grid(self, w, data=None) :
		gtk = self.gtk
		dialog = gtk.FileChooserDialog("Choose a grid file", None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OK, gtk.RESPONSE_OK)) 
		filter_grid = gtk.FileFilter()
		filter_grid.set_name("Grid file (python pickle file) - *.grid")
		filter_grid.add_pattern("*.grid")
		dialog.add_filter(filter_grid)
		filter_txt = gtk.FileFilter()
		filter_txt.set_name("Text file (python pickle file) - *.txt")
		filter_txt.add_pattern("*.txt")
		dialog.add_filter(filter_txt)
		filter_any = gtk.FileFilter()
		filter_any.set_name("any file")
		filter_any.add_pattern("*")
		dialog.add_filter(filter_any)
		
		response = dialog.run()
		if response == gtk.RESPONSE_OK:
			# THIS PART OF THE PROGRAM ASSUMES THAT THE FILE EXISTS AND IS VALID
			filename = dialog.get_filename()
			import pickle
			f = open(filename, 'rb')
			dic = pickle.load(f)
			f.close()
			self.load_save_dict(dic)
		dialog.destroy()
		
	def _save_grid(self, w, data=None) :
		if self.grid_folder == None :
			self._save_as_grid('','')
		else :
			import pickle
			f = open(self.grid_folder, 'wb')		# Create pickle object
			dic = self.get_save_dict()		# Create dict
			pickle.dump(dic, f, -1)
			f.close()
	def _save_as_grid(self, w, data=None) :
		gtk = self.gtk
		dialog = gtk.FileChooserDialog("Save a grid file", None, gtk.FILE_CHOOSER_ACTION_SAVE, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OK, gtk.RESPONSE_OK)) 
		filter_grid = gtk.FileFilter()
		filter_grid.set_name("Grid file (python pickle file) - *.grid")
		filter_grid.add_pattern("*.grid")
		dialog.add_filter(filter_grid)
		filter_txt = gtk.FileFilter()
		filter_txt.set_name("Text file (python pickle file) - *.txt")
		filter_txt.add_pattern("*.txt")
		dialog.add_filter(filter_txt)
		filter_any = gtk.FileFilter()
		filter_any.set_name("any file")
		filter_any.add_pattern("*")
		dialog.add_filter(filter_any)
		
		response = dialog.run()
		if response == gtk.RESPONSE_OK:
			filename = dialog.get_filename()
			ext = filename.split('.')[-1]
			if ext != 'txt' and ext != 'grid' :
				filename += '.grid'
			self.grid_folder = filename
			import pickle
			f = open(filename, 'wb')		# Create pickle object
			dic = self.get_save_dict()		# Create dict
			pickle.dump(dic, f, -1)
			f.close()
		dialog.destroy()
	def get_save_dict(self) :
		dic = {}
		dic['initiated'] = {'desc' : 'True if the grid is initiated <bool>', 'value' : bool(self.initiated)}
		reference_size = {'desc' : 'The width of the stripe used as a reference (int))', 'value' : int(self.reference_size)}
		dic['reference_size'] = reference_size
		if self.initiated :
			origin = {'desc' : 'The origin of the grid, coordinates in pixels (tuple, (x,y))', 'value' : tuple(self.origin)}
			origin_max = {'desc' : 'The maximum coordinates of the origin of the grid (tuple, (x,y))', 'value' : tuple(self.origin_max)}
			spacing = {'desc' : 'The spacing of the grid, values in pixels (tuple, (x,y))', 'value' : tuple(self.spacing)}
			spacing_max = {'desc' : 'The maximum spacing of the grid, values in pixels (tuple, (x,y))', 'value' : tuple(self.spacing_max)}
			size = {'desc' : 'The size of the grid, values in pixels (tuple, (x,y))', 'value' : tuple(self.size)}
			size_max = {'desc' : 'The maximum size of the grid, values in pixels (tuple, (x,y))', 'value' : tuple(self.size_max)}
			angle = {'desc' : 'The inclination of the grid, in degrees in trigonometric direction (float))', 'value' : float(self.angle)}
			dic['origin'] = origin
			dic['origin_max'] = origin_max
			dic['spacing'] = spacing
			dic['spacing_max'] = spacing_max
			dic['size'] = size
			dic['size_max'] = size_max
			dic['angle'] = angle
		return dic
	def load_save_dict(self, dic) :
		"""This function does NOT load the file, it takes as an input the input dict
		and initiates a grid.
		FOR THE MOMENT, this function requires the draw_set_grid function to be initiated
		(this is the inheritance of the fact that this function was initially written as
		a local importer - the Load grid button in the set grid menu -> constraint seems relaxed now"""
		print "-- Loading grid informations"
		self.initiated = dic['initiated']['value']
		if dic['initiated']['value'] :
			self.origin = dic['origin']['value']
			self.origin_max = dic['origin_max']['value']
			self.size = dic['size']['value']
			self.size_max = dic['size_max']['value']
			self.spacing = dic['spacing']['value']
			self.spacing_max = dic['spacing_max']['value']
			self.angle = dic['angle']['value']
			self.reference_size = dic['reference_size']['value']
			self._set_visible()
			if 	self.gtk_b_hide_show_grid != None :
				self.gtk_b_hide_show_grid.set_sensitive(True)
			if 	self.gtk_b_process_grid != None :
				self.gtk_b_process_grid.set_sensitive(True)
		else :
			self._grid_init(self.movie.get_size())
			self.reference_size = dic['reference_size']['value']
		self.grid_init2()	# Creating all the cells
		if self.v_set_visible :
			self._update_set_panel('')
		print "-- Done"
	def show_hide_grid(self, source=None, event=None):
		#if not self.initiated :
		#	self._grid_init(self.movie_size)
		if self.visible :
			self._set_invisible()
		else :
			self._set_visible()
