# Draws the contour based on the GMM

import cv, random, gtk
class Loader :
	def __init__(self, data) :
		self.loader_type = 'contour'
		self.source_channel = data['source_channel']	# The channel to be modified
		self.movie = data['movie']						# The source movie
		self.name_source = data['name_source']
		self.nb_files = self.movie.get_nb_frames()
		self.is_visible = False
		
		# Button
		l = self._bouton(gtk, 'Hide/show segmentation', self._show_contour, {})
		self.movie.display_m.add_button(l)
	def get_loader_type(self) :
		"""The first value is 'is_inherited'"""
		return (True, self.loader_type)
		
	def update(self) :
		pass
	def init(self) :
		"""The final initialization"""
	def get_nb_frames(self) :
		return self.nb_files
	def get_frame_path(self, i) :
		print 'contour module has no get_frame_path option'
	def _set_contour(self, im_base, im_threshold) :
		c = plt.contour(im_threshold)
		p = c.collections[0].get_paths()[0].vertices.astype(int)
		im_base[p] = 255
		return im_base
		
	def overlay(self, sou_cv, i) :
		color = self.source_channel.loader.get_frame_CV(i)	# importing image
		#print (cv.GetSize(sou_cv), sou_cv.depth, sou_cv.channels)
		out = cv.CreateImage(cv.GetSize(color), 8, 3)
		cv.Copy(sou_cv, out)
		if self.is_visible :
			threshold = 10
			# Initialization
			image = cv.CreateImage(cv.GetSize(color), 8, 1)		# Create output image
			cv.CvtColor(color, image, cv.CV_RGB2GRAY)
			cv.Canny(image, image, 255, 255, aperture_size=3) # Canny Edge extraction
			
			# Extracting contour
			out_l = []		# Output list of contours
			cont = cv.FindContours(image, cv.CreateMemStorage(), mode=cv.CV_RETR_CCOMP, method=cv.CV_CHAIN_APPROX_SIMPLE, offset=(0, 0))	# Init - Returns a cvSeq
			
			while cont[:] != [] :
				if cv.ContourArea(cont) >= threshold :		# Replace with proper value
					out_l.append(cont)	
				im_tmp = cv.CreateImage(cv.GetSize(image), 8, 1) # Temporary image (FindContours modifies the initial image)
				cv.Copy(image, im_tmp)				# Fill the temporary image
				cont = cv.FindContours(im_tmp, cv.CreateMemStorage(), mode=cv.CV_RETR_CCOMP, method=cv.CV_CHAIN_APPROX_SIMPLE, offset=(0, 0))	# Returns a cvSeq
				cv.FillPoly(image, [cont], cv.RGB(0, 0, 0), lineType=8, shift=0)	# delete the contour on the image
			for c in out_l :
				cv.DrawContours(out, c, cv.RGB(random.randint(0,255), random.randint(0,255), random.randint(0,255)), cv.RGB(0, 100, 0), 0, thickness=2, lineType=8, offset=(0, 0))

		return out	# Return image

		
	def get_frame_CV(self, i) :
		color = self.source_channel.loader.get_frame_CV(i)
		
		# Initialization
		image = cv.CreateImage(cv.GetSize(color), 8, 1)		# Create output image
		cv.CvtColor(color, image, cv.CV_RGB2GRAY)
		cv.Canny(image, image, 255, 255, aperture_size=3) # Canny Edge extraction
		cv.CvtColor(image, color, cv.CV_GRAY2RGB)
		return color
	def _show_contour(self, w, data=None) :
		self.is_visible = not self.is_visible
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	 # On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()# This packs the button into the window (a GTK container).
		return bouton 
